package be.jeffcheasey88.peeratcode.parser.state;

import java.util.function.BiConsumer;

import be.jeffcheasey88.peeratcode.parser.Bag;
import be.jeffcheasey88.peeratcode.parser.TokenValidator;

public class RedirectStateTree<E, T extends E> extends StateTree<T>{
	
	private StateTree<E> redirect;
	private BiConsumer<Bag, Bag> group;

	public RedirectStateTree(StateTree<E> redirect, BiConsumer<Bag, Bag> group){
		super();
		this.redirect = redirect;
		this.group = group;
	}
	
	@Override
	BuilderStateTree<T, ?> internalSeed(TokenValidator validator, T element){
		Bag currentBag = validator.getBag();
		Bag localBag = new Bag();
		
		TokenValidator branch = validator.branch();
		branch.setBag(localBag);
		Object builded = redirect.internalSeed(branch, (E) element);
		if(builded == null) return null;

		this.group.accept(currentBag, localBag);
		branch.setBag(currentBag);
		validator.merge(branch);
		
		return super.internalSeed(validator, element);
	}
}

